macro(stm32cube_load LOAD_NAME CUBE_PROJECT_DIR)
    file(READ "${CUBE_PROJECT_DIR}/.cproject" CPROJECT_CONTENT)
    string(REGEX MATCH "<[ \t]*option[^<>]*name=\"Defined symbols ....\".*" CPROJECT_CONTENT "${CPROJECT_CONTENT}")
    string(REGEX MATCH "<[ \t]*/[ \t]*option[ \t]*>.*" CPROJECT_CONTENT_DEL "${CPROJECT_CONTENT}")
    string(REPLACE "${CPROJECT_CONTENT_DEL}" "" CPROJECT_CONTENT "${CPROJECT_CONTENT}")
    string(REPLACE "&quot;" "" CPROJECT_CONTENT "${CPROJECT_CONTENT}")
    string(REPLACE "/>" ";" CPROJECT_CONTENT "${CPROJECT_CONTENT}")
    foreach(VALUE_DEFINITION ${CPROJECT_CONTENT})
        string(REGEX MATCH "value=\"(.*)\"" DEFINITION "${VALUE_DEFINITION}")
        list(APPEND ${LOAD_NAME}_DEFINITIONS ${CMAKE_MATCH_1})
    endforeach()

    file(GLOB_RECURSE ${LOAD_NAME}_LINKER_SCRIPTS ${CUBE_PROJECT_DIR}/*.ld)
    file(GLOB_RECURSE ${LOAD_NAME}_HEADER_FILES ${CUBE_PROJECT_DIR}/*.h)
    file(GLOB_RECURSE ${LOAD_NAME}_SOURCE_FILES ${CUBE_PROJECT_DIR}/*.c ${CUBE_PROJECT_DIR}/*.s)

    foreach(HAL_HEADER_FILE ${${LOAD_NAME}_HEADER_FILES})
        string(REGEX MATCH ".*/(Inc|Include)/" INCLUDE_DIR ${HAL_HEADER_FILE})
        list(APPEND ${LOAD_NAME}_INCLUDE_DIRS ${INCLUDE_DIR})
    endforeach()
    if(${LOAD_NAME}_INCLUDE_DIRS)
        list(REMOVE_DUPLICATES ${LOAD_NAME}_INCLUDE_DIRS)
    endif()
    
    unset(CPROJECT_CONTENT)
    unset(CPROJECT_CONTENT_DEL)
    unset(DEFINITION)
    unset(INCLUDE_DIR)
endmacro()
